commit 55fa6993e257895a96490227c3b085328887990e
Author: Leszek Koltunski <leszek@koltunski.pl>
Date:   Thu Oct 21 16:54:47 2021 +0200

    Systematic names for the meshes.

diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyBandaged2Bar.java b/src/main/java/org/distorted/objectlib/objects/TwistyBandaged2Bar.java
index 330adac8..0fdef15c 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyBandaged2Bar.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyBandaged2Bar.java
@@ -62,7 +62,7 @@ public class TwistyBandaged2Bar extends TwistyBandagedAbstract
 
   protected int getResource(int[] numLayers)
     {
-    return R.raw.ban2;
+    return R.raw.ban2_3;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyBandaged3Plate.java b/src/main/java/org/distorted/objectlib/objects/TwistyBandaged3Plate.java
index a5779ab0..ce5a22de 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyBandaged3Plate.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyBandaged3Plate.java
@@ -75,7 +75,7 @@ public class TwistyBandaged3Plate extends TwistyBandagedAbstract
 
   protected int getResource(int[] numLayers)
     {
-    return R.raw.ban3;
+    return R.raw.ban3_3;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyBandagedEvil.java b/src/main/java/org/distorted/objectlib/objects/TwistyBandagedEvil.java
index 8f50f227..8d31c322 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyBandagedEvil.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyBandagedEvil.java
@@ -203,7 +203,7 @@ public class TwistyBandagedEvil extends TwistyBandagedAbstract
 
   protected int getResource(int[] numLayers)
     {
-    return R.raw.ban4;
+    return R.raw.ban4_3;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyBandagedFused.java b/src/main/java/org/distorted/objectlib/objects/TwistyBandagedFused.java
index aa796870..10af33c0 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyBandagedFused.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyBandagedFused.java
@@ -62,7 +62,7 @@ public class TwistyBandagedFused extends TwistyBandagedAbstract
 
   protected int getResource(int[] numLayers)
     {
-    return R.raw.ban1;
+    return R.raw.ban1_3;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyCuboid.java b/src/main/java/org/distorted/objectlib/objects/TwistyCuboid.java
index 39c1c414..590e5ad7 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyCuboid.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyCuboid.java
@@ -183,15 +183,15 @@ public class TwistyCuboid extends Twisty6
 
     switch(x)
       {
-      case 2: return y==2 ? R.raw.cube2 : R.raw.cu_232;
+      case 2: return y==2 ? R.raw.cube_2 : R.raw.cu_232;
       case 3: switch(y)
                 {
                 case 2: return R.raw.cu_323;
-                case 3: return R.raw.cube3;
+                case 3: return R.raw.cube_3;
                 case 4: return R.raw.cu_343;
                 }
-      case 4: return R.raw.cube4;
-      case 5: return R.raw.cube5;
+      case 4: return R.raw.cube_4;
+      case 5: return R.raw.cube_5;
       }
 
     return 0;
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyDiamond.java b/src/main/java/org/distorted/objectlib/objects/TwistyDiamond.java
index 317a89d0..7f517959 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyDiamond.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyDiamond.java
@@ -100,9 +100,9 @@ public class TwistyDiamond extends Twisty8
     {
     switch(numLayers[0])
       {
-      case 2: return R.raw.diam2;
-      case 3: return R.raw.diam3;
-      case 4: return R.raw.diam4;
+      case 2: return R.raw.diam_2;
+      case 3: return R.raw.diam_3;
+      case 4: return R.raw.diam_4;
       }
 
     return 0;
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyDino.java b/src/main/java/org/distorted/objectlib/objects/TwistyDino.java
index 23ba9322..137c04f8 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyDino.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyDino.java
@@ -90,7 +90,7 @@ abstract class TwistyDino extends Twisty6
 
   protected int getResource(int[] numLayers)
     {
-    return R.raw.dino;
+    return R.raw.dino_3;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyHelicopter.java b/src/main/java/org/distorted/objectlib/objects/TwistyHelicopter.java
index b8743e17..ae58e274 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyHelicopter.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyHelicopter.java
@@ -102,7 +102,7 @@ public class TwistyHelicopter extends Twisty6
 
   protected int getResource(int[] numLayers)
     {
-    return R.raw.heli;
+    return R.raw.heli_3;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyIvy.java b/src/main/java/org/distorted/objectlib/objects/TwistyIvy.java
index 60a6611b..112e4c0a 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyIvy.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyIvy.java
@@ -91,7 +91,7 @@ public class TwistyIvy extends Twisty6
 
   protected int getResource(int[] numLayers)
     {
-    return R.raw.ivy;
+    return R.raw.ivy_2;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyJing.java b/src/main/java/org/distorted/objectlib/objects/TwistyJing.java
index 4ce775fd..56c4de57 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyJing.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyJing.java
@@ -93,7 +93,7 @@ public class TwistyJing extends Twisty4
 
   protected int getResource(int[] numLayers)
     {
-    return R.raw.jing;
+    return R.raw.jing_2;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyKilominx.java b/src/main/java/org/distorted/objectlib/objects/TwistyKilominx.java
index e11397c6..c8d10ee3 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyKilominx.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyKilominx.java
@@ -92,8 +92,8 @@ public class TwistyKilominx extends TwistyMinx
     {
     switch(numLayers[0])
       {
-      case 3: return R.raw.kilo3;
-      case 5: return R.raw.kilo5;
+      case 3: return R.raw.kilo_3;
+      case 5: return R.raw.kilo_5;
       }
 
     return 0;
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyMegaminx.java b/src/main/java/org/distorted/objectlib/objects/TwistyMegaminx.java
index 20b4838f..dc936cfb 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyMegaminx.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyMegaminx.java
@@ -79,8 +79,8 @@ public class TwistyMegaminx extends TwistyMinx
     {
     switch(numLayers[0])
       {
-      case 3: return R.raw.mega3;
-      case 5: return R.raw.mega5;
+      case 3: return R.raw.mega_3;
+      case 5: return R.raw.mega_5;
       }
 
     return 0;
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyMirror.java b/src/main/java/org/distorted/objectlib/objects/TwistyMirror.java
index af4704b4..eff442ef 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyMirror.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyMirror.java
@@ -125,8 +125,8 @@ public class TwistyMirror extends Twisty6
     {
     switch(numLayers[0])
       {
-      case 2: return R.raw.mirr2;
-      case 3: return R.raw.mirr3;
+      case 2: return R.raw.mirr_2;
+      case 3: return R.raw.mirr_3;
       }
 
     return 0;
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyPyraminx.java b/src/main/java/org/distorted/objectlib/objects/TwistyPyraminx.java
index 2d77adae..0d039621 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyPyraminx.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyPyraminx.java
@@ -84,9 +84,9 @@ public class TwistyPyraminx extends Twisty4
     {
     switch(numLayers[0])
       {
-      case 3: return R.raw.pyra3;
-      case 4: return R.raw.pyra4;
-      case 5: return R.raw.pyra5;
+      case 3: return R.raw.pyra_3;
+      case 4: return R.raw.pyra_4;
+      case 5: return R.raw.pyra_5;
       }
 
     return 0;
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyRedi.java b/src/main/java/org/distorted/objectlib/objects/TwistyRedi.java
index 86d152b1..a2814ba7 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyRedi.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyRedi.java
@@ -94,7 +94,7 @@ public class TwistyRedi extends Twisty6
 
   protected int getResource(int[] numLayers)
     {
-    return R.raw.redi;
+    return R.raw.redi_3;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyRex.java b/src/main/java/org/distorted/objectlib/objects/TwistyRex.java
index 783bd1a6..f15e586b 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyRex.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyRex.java
@@ -89,7 +89,7 @@ public class TwistyRex extends Twisty6
 
   protected int getResource(int[] numLayers)
     {
-    return R.raw.rex;
+    return R.raw.rex_3;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistySkewb.java b/src/main/java/org/distorted/objectlib/objects/TwistySkewb.java
index e380ff6f..1be72ebb 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistySkewb.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistySkewb.java
@@ -92,8 +92,8 @@ public class TwistySkewb extends Twisty6
     {
     switch(numLayers[0])
       {
-      case 2: return R.raw.skew2;
-      case 3: return R.raw.skew3;
+      case 2: return R.raw.skew_2;
+      case 3: return R.raw.skew_3;
       }
 
     return 0;
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistySquare1.java b/src/main/java/org/distorted/objectlib/objects/TwistySquare1.java
index c5820d6e..ef5fe6de 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistySquare1.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistySquare1.java
@@ -66,7 +66,7 @@ public class TwistySquare1 extends TwistySquare
 
   protected int getResource(int[] numLayers)
     {
-    return R.raw.squa1;
+    return R.raw.squ1_3;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistySquare2.java b/src/main/java/org/distorted/objectlib/objects/TwistySquare2.java
index 7e08137d..6e6858fb 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistySquare2.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistySquare2.java
@@ -84,7 +84,7 @@ public class TwistySquare2 extends TwistySquare
 
   protected int getResource(int[] numLayers)
     {
-    return R.raw.squa2;
+    return R.raw.squ2_3;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/java/org/distorted/objectlib/objects/TwistyUltimate.java b/src/main/java/org/distorted/objectlib/objects/TwistyUltimate.java
index a93c9bcb..080527c4 100644
--- a/src/main/java/org/distorted/objectlib/objects/TwistyUltimate.java
+++ b/src/main/java/org/distorted/objectlib/objects/TwistyUltimate.java
@@ -97,7 +97,7 @@ public class TwistyUltimate extends Twisty12
 
   protected int getResource(int[] numLayers)
     {
-    return R.raw.ulti;
+    return R.raw.ulti_2;
     }
 
 ///////////////////////////////////////////////////////////////////////////////////////////////////
diff --git a/src/main/res/raw/ban1.dmesh b/src/main/res/raw/ban1.dmesh
deleted file mode 100644
index b9d7abdf..00000000
Binary files a/src/main/res/raw/ban1.dmesh and /dev/null differ
diff --git a/src/main/res/raw/ban1_3.dmesh b/src/main/res/raw/ban1_3.dmesh
new file mode 100644
index 00000000..b9d7abdf
Binary files /dev/null and b/src/main/res/raw/ban1_3.dmesh differ
diff --git a/src/main/res/raw/ban2.dmesh b/src/main/res/raw/ban2.dmesh
deleted file mode 100644
index 7b914a4c..00000000
Binary files a/src/main/res/raw/ban2.dmesh and /dev/null differ
diff --git a/src/main/res/raw/ban2_3.dmesh b/src/main/res/raw/ban2_3.dmesh
new file mode 100644
index 00000000..7b914a4c
Binary files /dev/null and b/src/main/res/raw/ban2_3.dmesh differ
diff --git a/src/main/res/raw/ban3.dmesh b/src/main/res/raw/ban3.dmesh
deleted file mode 100644
index c8d5d2b7..00000000
Binary files a/src/main/res/raw/ban3.dmesh and /dev/null differ
diff --git a/src/main/res/raw/ban3_3.dmesh b/src/main/res/raw/ban3_3.dmesh
new file mode 100644
index 00000000..c8d5d2b7
Binary files /dev/null and b/src/main/res/raw/ban3_3.dmesh differ
diff --git a/src/main/res/raw/ban4.dmesh b/src/main/res/raw/ban4.dmesh
deleted file mode 100644
index e3f207ad..00000000
Binary files a/src/main/res/raw/ban4.dmesh and /dev/null differ
diff --git a/src/main/res/raw/ban4_3.dmesh b/src/main/res/raw/ban4_3.dmesh
new file mode 100644
index 00000000..e3f207ad
Binary files /dev/null and b/src/main/res/raw/ban4_3.dmesh differ
diff --git a/src/main/res/raw/cube2.dmesh b/src/main/res/raw/cube2.dmesh
deleted file mode 100644
index fbebccf0..00000000
Binary files a/src/main/res/raw/cube2.dmesh and /dev/null differ
diff --git a/src/main/res/raw/cube3.dmesh b/src/main/res/raw/cube3.dmesh
deleted file mode 100644
index ce97963d..00000000
Binary files a/src/main/res/raw/cube3.dmesh and /dev/null differ
diff --git a/src/main/res/raw/cube4.dmesh b/src/main/res/raw/cube4.dmesh
deleted file mode 100644
index 895f9634..00000000
Binary files a/src/main/res/raw/cube4.dmesh and /dev/null differ
diff --git a/src/main/res/raw/cube5.dmesh b/src/main/res/raw/cube5.dmesh
deleted file mode 100644
index 7e2cd422..00000000
Binary files a/src/main/res/raw/cube5.dmesh and /dev/null differ
diff --git a/src/main/res/raw/cube_2.dmesh b/src/main/res/raw/cube_2.dmesh
new file mode 100644
index 00000000..fbebccf0
Binary files /dev/null and b/src/main/res/raw/cube_2.dmesh differ
diff --git a/src/main/res/raw/cube_3.dmesh b/src/main/res/raw/cube_3.dmesh
new file mode 100644
index 00000000..ce97963d
Binary files /dev/null and b/src/main/res/raw/cube_3.dmesh differ
diff --git a/src/main/res/raw/cube_4.dmesh b/src/main/res/raw/cube_4.dmesh
new file mode 100644
index 00000000..895f9634
Binary files /dev/null and b/src/main/res/raw/cube_4.dmesh differ
diff --git a/src/main/res/raw/cube_5.dmesh b/src/main/res/raw/cube_5.dmesh
new file mode 100644
index 00000000..7e2cd422
Binary files /dev/null and b/src/main/res/raw/cube_5.dmesh differ
diff --git a/src/main/res/raw/diam2.dmesh b/src/main/res/raw/diam2.dmesh
deleted file mode 100644
index 2ffc96ec..00000000
Binary files a/src/main/res/raw/diam2.dmesh and /dev/null differ
diff --git a/src/main/res/raw/diam3.dmesh b/src/main/res/raw/diam3.dmesh
deleted file mode 100644
index 64a9247d..00000000
Binary files a/src/main/res/raw/diam3.dmesh and /dev/null differ
diff --git a/src/main/res/raw/diam4.dmesh b/src/main/res/raw/diam4.dmesh
deleted file mode 100644
index ab6de2ee..00000000
Binary files a/src/main/res/raw/diam4.dmesh and /dev/null differ
diff --git a/src/main/res/raw/diam_2.dmesh b/src/main/res/raw/diam_2.dmesh
new file mode 100644
index 00000000..2ffc96ec
Binary files /dev/null and b/src/main/res/raw/diam_2.dmesh differ
diff --git a/src/main/res/raw/diam_3.dmesh b/src/main/res/raw/diam_3.dmesh
new file mode 100644
index 00000000..64a9247d
Binary files /dev/null and b/src/main/res/raw/diam_3.dmesh differ
diff --git a/src/main/res/raw/diam_4.dmesh b/src/main/res/raw/diam_4.dmesh
new file mode 100644
index 00000000..ab6de2ee
Binary files /dev/null and b/src/main/res/raw/diam_4.dmesh differ
diff --git a/src/main/res/raw/dino.dmesh b/src/main/res/raw/dino.dmesh
deleted file mode 100644
index 6a86ae85..00000000
Binary files a/src/main/res/raw/dino.dmesh and /dev/null differ
diff --git a/src/main/res/raw/dino_3.dmesh b/src/main/res/raw/dino_3.dmesh
new file mode 100644
index 00000000..6a86ae85
Binary files /dev/null and b/src/main/res/raw/dino_3.dmesh differ
diff --git a/src/main/res/raw/heli.dmesh b/src/main/res/raw/heli.dmesh
deleted file mode 100644
index f50e871f..00000000
Binary files a/src/main/res/raw/heli.dmesh and /dev/null differ
diff --git a/src/main/res/raw/heli_3.dmesh b/src/main/res/raw/heli_3.dmesh
new file mode 100644
index 00000000..f50e871f
Binary files /dev/null and b/src/main/res/raw/heli_3.dmesh differ
diff --git a/src/main/res/raw/ivy.dmesh b/src/main/res/raw/ivy.dmesh
deleted file mode 100644
index 831b7d3c..00000000
Binary files a/src/main/res/raw/ivy.dmesh and /dev/null differ
diff --git a/src/main/res/raw/ivy_2.dmesh b/src/main/res/raw/ivy_2.dmesh
new file mode 100644
index 00000000..831b7d3c
Binary files /dev/null and b/src/main/res/raw/ivy_2.dmesh differ
diff --git a/src/main/res/raw/jing.dmesh b/src/main/res/raw/jing.dmesh
deleted file mode 100644
index 3d79603c..00000000
Binary files a/src/main/res/raw/jing.dmesh and /dev/null differ
diff --git a/src/main/res/raw/jing_2.dmesh b/src/main/res/raw/jing_2.dmesh
new file mode 100644
index 00000000..3d79603c
Binary files /dev/null and b/src/main/res/raw/jing_2.dmesh differ
diff --git a/src/main/res/raw/kilo3.dmesh b/src/main/res/raw/kilo3.dmesh
deleted file mode 100644
index 89c96732..00000000
Binary files a/src/main/res/raw/kilo3.dmesh and /dev/null differ
diff --git a/src/main/res/raw/kilo5.dmesh b/src/main/res/raw/kilo5.dmesh
deleted file mode 100644
index 91a82ab8..00000000
Binary files a/src/main/res/raw/kilo5.dmesh and /dev/null differ
diff --git a/src/main/res/raw/kilo_3.dmesh b/src/main/res/raw/kilo_3.dmesh
new file mode 100644
index 00000000..89c96732
Binary files /dev/null and b/src/main/res/raw/kilo_3.dmesh differ
diff --git a/src/main/res/raw/kilo_5.dmesh b/src/main/res/raw/kilo_5.dmesh
new file mode 100644
index 00000000..91a82ab8
Binary files /dev/null and b/src/main/res/raw/kilo_5.dmesh differ
diff --git a/src/main/res/raw/mega3.dmesh b/src/main/res/raw/mega3.dmesh
deleted file mode 100644
index faf0be11..00000000
Binary files a/src/main/res/raw/mega3.dmesh and /dev/null differ
diff --git a/src/main/res/raw/mega5.dmesh b/src/main/res/raw/mega5.dmesh
deleted file mode 100644
index 85c39c6e..00000000
Binary files a/src/main/res/raw/mega5.dmesh and /dev/null differ
diff --git a/src/main/res/raw/mega_3.dmesh b/src/main/res/raw/mega_3.dmesh
new file mode 100644
index 00000000..faf0be11
Binary files /dev/null and b/src/main/res/raw/mega_3.dmesh differ
diff --git a/src/main/res/raw/mega_5.dmesh b/src/main/res/raw/mega_5.dmesh
new file mode 100644
index 00000000..85c39c6e
Binary files /dev/null and b/src/main/res/raw/mega_5.dmesh differ
diff --git a/src/main/res/raw/mirr2.dmesh b/src/main/res/raw/mirr2.dmesh
deleted file mode 100644
index 152caec7..00000000
Binary files a/src/main/res/raw/mirr2.dmesh and /dev/null differ
diff --git a/src/main/res/raw/mirr3.dmesh b/src/main/res/raw/mirr3.dmesh
deleted file mode 100644
index a1c12104..00000000
Binary files a/src/main/res/raw/mirr3.dmesh and /dev/null differ
diff --git a/src/main/res/raw/mirr_2.dmesh b/src/main/res/raw/mirr_2.dmesh
new file mode 100644
index 00000000..152caec7
Binary files /dev/null and b/src/main/res/raw/mirr_2.dmesh differ
diff --git a/src/main/res/raw/mirr_3.dmesh b/src/main/res/raw/mirr_3.dmesh
new file mode 100644
index 00000000..a1c12104
Binary files /dev/null and b/src/main/res/raw/mirr_3.dmesh differ
diff --git a/src/main/res/raw/pyra3.dmesh b/src/main/res/raw/pyra3.dmesh
deleted file mode 100644
index e536f7d2..00000000
Binary files a/src/main/res/raw/pyra3.dmesh and /dev/null differ
diff --git a/src/main/res/raw/pyra4.dmesh b/src/main/res/raw/pyra4.dmesh
deleted file mode 100644
index d2179266..00000000
Binary files a/src/main/res/raw/pyra4.dmesh and /dev/null differ
diff --git a/src/main/res/raw/pyra5.dmesh b/src/main/res/raw/pyra5.dmesh
deleted file mode 100644
index b1b43016..00000000
Binary files a/src/main/res/raw/pyra5.dmesh and /dev/null differ
diff --git a/src/main/res/raw/pyra_3.dmesh b/src/main/res/raw/pyra_3.dmesh
new file mode 100644
index 00000000..e536f7d2
Binary files /dev/null and b/src/main/res/raw/pyra_3.dmesh differ
diff --git a/src/main/res/raw/pyra_4.dmesh b/src/main/res/raw/pyra_4.dmesh
new file mode 100644
index 00000000..d2179266
Binary files /dev/null and b/src/main/res/raw/pyra_4.dmesh differ
diff --git a/src/main/res/raw/pyra_5.dmesh b/src/main/res/raw/pyra_5.dmesh
new file mode 100644
index 00000000..b1b43016
Binary files /dev/null and b/src/main/res/raw/pyra_5.dmesh differ
diff --git a/src/main/res/raw/redi.dmesh b/src/main/res/raw/redi.dmesh
deleted file mode 100644
index 4d30d35e..00000000
Binary files a/src/main/res/raw/redi.dmesh and /dev/null differ
diff --git a/src/main/res/raw/redi_3.dmesh b/src/main/res/raw/redi_3.dmesh
new file mode 100644
index 00000000..4d30d35e
Binary files /dev/null and b/src/main/res/raw/redi_3.dmesh differ
diff --git a/src/main/res/raw/rex.dmesh b/src/main/res/raw/rex.dmesh
deleted file mode 100644
index ac0dfe9e..00000000
Binary files a/src/main/res/raw/rex.dmesh and /dev/null differ
diff --git a/src/main/res/raw/rex_3.dmesh b/src/main/res/raw/rex_3.dmesh
new file mode 100644
index 00000000..ac0dfe9e
Binary files /dev/null and b/src/main/res/raw/rex_3.dmesh differ
diff --git a/src/main/res/raw/skew2.dmesh b/src/main/res/raw/skew2.dmesh
deleted file mode 100644
index 637dbc83..00000000
Binary files a/src/main/res/raw/skew2.dmesh and /dev/null differ
diff --git a/src/main/res/raw/skew3.dmesh b/src/main/res/raw/skew3.dmesh
deleted file mode 100644
index deae07bf..00000000
Binary files a/src/main/res/raw/skew3.dmesh and /dev/null differ
diff --git a/src/main/res/raw/skew_2.dmesh b/src/main/res/raw/skew_2.dmesh
new file mode 100644
index 00000000..637dbc83
Binary files /dev/null and b/src/main/res/raw/skew_2.dmesh differ
diff --git a/src/main/res/raw/skew_3.dmesh b/src/main/res/raw/skew_3.dmesh
new file mode 100644
index 00000000..deae07bf
Binary files /dev/null and b/src/main/res/raw/skew_3.dmesh differ
diff --git a/src/main/res/raw/squ1_3.dmesh b/src/main/res/raw/squ1_3.dmesh
new file mode 100644
index 00000000..239497d6
Binary files /dev/null and b/src/main/res/raw/squ1_3.dmesh differ
diff --git a/src/main/res/raw/squ2_3.dmesh b/src/main/res/raw/squ2_3.dmesh
new file mode 100644
index 00000000..56ff0c85
Binary files /dev/null and b/src/main/res/raw/squ2_3.dmesh differ
diff --git a/src/main/res/raw/squa1.dmesh b/src/main/res/raw/squa1.dmesh
deleted file mode 100644
index 239497d6..00000000
Binary files a/src/main/res/raw/squa1.dmesh and /dev/null differ
diff --git a/src/main/res/raw/squa2.dmesh b/src/main/res/raw/squa2.dmesh
deleted file mode 100644
index 56ff0c85..00000000
Binary files a/src/main/res/raw/squa2.dmesh and /dev/null differ
diff --git a/src/main/res/raw/ulti.dmesh b/src/main/res/raw/ulti.dmesh
deleted file mode 100644
index 27bfde0c..00000000
Binary files a/src/main/res/raw/ulti.dmesh and /dev/null differ
diff --git a/src/main/res/raw/ulti_2.dmesh b/src/main/res/raw/ulti_2.dmesh
new file mode 100644
index 00000000..27bfde0c
Binary files /dev/null and b/src/main/res/raw/ulti_2.dmesh differ